#include "m_pd.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <shellapi.h>



//main (void)
//PROCESS_INFORMATION pi;
 //STARTUPINFO si;
//class
static t_class *openfile_class; 



typedef struct _openfile {
  t_object  x_obj; //must have t_object first
  t_symbol s_filename;
} t_openfile; //structure
//dataspace

void openfile_bang(t_openfile *x)
{
	char filePath[100];
	sprintf(filePath, "%s", x->s_filename);
	ShellExecute(NULL,"open",filePath,"","",SW_SHOW);
	outlet_bang(x->x_obj.ob_outlet);
}

static void openfile_openfile(t_openfile *x, t_symbol *s)
{
	x->s_filename = *s;
	
}
//methodspace
//constructor must be type void

void *openfile_new(t_symbol *s) 
{
  t_openfile *x = (t_openfile *)pd_new(openfile_class);
  x->s_filename = *s;
  outlet_new(&x->x_obj, &s_symbol);
  
  return (void *)x;
}

//generate class
void openfile_setup(void)
{
  openfile_class = class_new(gensym("openfile"), //name class
        (t_newmethod)openfile_new, //define constructor
        0, sizeof(t_openfile), //0 is default destructor, define mem allocation size
        CLASS_DEFAULT, A_DEFSYMBOL, 0); //default class graphical element, arguments (end with 0)

  class_addbang(openfile_class, openfile_bang); //add methodspace to class
	class_addmethod(openfile_class, 
        (t_newmethod)openfile_openfile, gensym("openfile"),
        A_DEFSYMBOL, 0);
}

